<?php

namespace Drupal\cmlmigrations\Controller;

use Drupal\Core\Controller\ControllerBase;

/**
 * Controller routines for page example routes.
 */
class FixVariation extends ControllerBase {

  /**
   * Find variations.
   */
  public static function findVariations($id1c) {
    $variations = [];

    if ($id1c) {
      $query = \Drupal::database()->select('migrate_map_cml_product_variation', 'variation_migration');
      $query->fields('variation_migration', ['destid1', 'sourceid1']);
      $query->condition('sourceid1', "%$id1c%", 'LIKE');
      $res = $query->execute();

      if ($res) {
        foreach ($res as $key => $value) {
          $variations[] = [
            'src' => $value->sourceid1,
            'target_id' => $value->destid1,
          ];
        }
      }
    }
    return $variations;
  }

  /**
   * Fix on Save.
   */
  public static function fixOnSave($product) {

  }

  /**
   * Fix On Insert.
   */
  public static function fixOnInsert($product) {
    $uuid = $product->uuid->value;
    $variations = self::findVariations($uuid);
    $product->variations->setValue($variations);
    $product->save();
  }

}
